diff -r fb51f5b4aa4c trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_fields.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1591,247 +1506,236 @@
             yesterday = today - datetime.timedelta(1)
             default_date = datetime.date(2000, 1, 1)
 
-            date1_id = self.date.create({
-                'date': today,
-                })
-            self.assert_(date1_id)
-
-            date1 = self.date.read(date1_id, ['date'])
-            self.assert_(date1['date'] == today)
-
-            date_ids = self.date.search([
-                ('date', '=', today),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '=', tomorrow),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '=', False),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '!=', today),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '!=', tomorrow),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '!=', False),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', 'in', [today]),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', 'in', [tomorrow]),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', 'in', [False]),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', 'in', []),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', 'not in', [today]),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', 'not in', [tomorrow]),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', 'not in', [False]),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', 'not in', []),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '<', tomorrow),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '<', yesterday),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '<', today),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '<=', today),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '<=', yesterday),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '<=', tomorrow),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '>', tomorrow),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '>', yesterday),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '>', today),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '>=', tomorrow),
-                ])
-            self.assert_(date_ids == [])
-
-            date_ids = self.date.search([
-                ('date', '>=', yesterday),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date_ids = self.date.search([
-                ('date', '>=', today),
-                ])
-            self.assert_(date_ids == [date1_id])
-
-            date2_id = self.date.create({
-                'date': yesterday,
-                })
-            self.assert_(date2_id)
-
-            date2 = self.date.read(date2_id, ['date'])
-            self.assert_(date2['date'] == yesterday)
-
-            date_ids = self.date.search([
-                ('date', '=', yesterday),
-                ])
-            self.assert_(date_ids == [date2_id])
-
-            date_ids = self.date.search([
-                ('date', 'in', [yesterday, today]),
-                ])
-            self.assert_(date_ids == [date1_id, date2_id])
-
-            date_ids = self.date.search([
-                ('date', 'not in', [yesterday, today]),
-                ])
-            self.assert_(date_ids == [])
-
-            date3_id = self.date.create({})
-            self.assert_(date3_id)
-
-            date3 = self.date.read(date3_id, ['date'])
-            self.assert_(date3['date'] == None)
-
-            date4_id = self.date_default.create({})
-            self.assert_(date4_id)
-
-            date4 = self.date_default.read(date4_id, ['date'])
-            self.assert_(date4['date'] == default_date)
-
-            self.date.write(date1_id, {
-                'date': yesterday,
-                })
-            date1 = self.date.read(date1_id, ['date'])
-            self.assert_(date1['date'] == yesterday)
-
-            self.date.write(date2_id, {
-                'date': today,
-                })
-            date2 = self.date.read(date2_id, ['date'])
-            self.assert_(date2['date'] == today)
-
-            self.failUnlessRaises(Exception, self.date.create, {
-                'date': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.date.write, date1_id, {
-                'date': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.date.create, {
-                'date': 1,
-                })
-
-            self.failUnlessRaises(Exception, self.date.write, date1_id, {
-                'date': 1,
-                })
-
-            self.failUnlessRaises(Exception, self.date.create, {
-                'date': datetime.datetime.now(),
-                })
-
-            self.failUnlessRaises(Exception, self.date.write, date1_id, {
-                'date': datetime.datetime.now(),
-                })
-
-            self.failUnlessRaises(Exception, self.date.create, {
-                'date': '2009-13-01',
-                })
-
-            self.failUnlessRaises(Exception, self.date.write, date1_id, {
-                'date': '2009-02-29',
-                })
-
-            date5_id = self.date.create({
-                'date': '2009-01-01',
-                })
-            self.assert_(date5_id)
-            date5 = self.date.read(date5_id, ['date'])
-            self.assert_(date5['date'] == datetime.date(2009, 1, 1))
-
-            self.failUnlessRaises(Exception, self.date_required.create, {})
+            date1 = self.date.create({
+                    'date': today,
+                    })
+            self.assert_(date1)
+            self.assertEqual(date1.date, today)
+
+            dates = self.date.search([
+                    ('date', '=', today),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '=', tomorrow),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '=', None),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '!=', today),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '!=', tomorrow),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '!=', None),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', 'in', [today]),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', 'in', [tomorrow]),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', 'in', [None]),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', 'in', []),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', 'not in', [today]),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', 'not in', [tomorrow]),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', 'not in', [None]),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', 'not in', []),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '<', tomorrow),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '<', yesterday),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '<', today),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '<=', today),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '<=', yesterday),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '<=', tomorrow),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '>', tomorrow),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '>', yesterday),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '>', today),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '>=', tomorrow),
+                    ])
+            self.assertEqual(dates, [])
+
+            dates = self.date.search([
+                    ('date', '>=', yesterday),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            dates = self.date.search([
+                    ('date', '>=', today),
+                    ])
+            self.assertEqual(dates, [date1])
+
+            date2 = self.date.create({
+                    'date': yesterday,
+                    })
+            self.assert_(date2)
+            self.assertEqual(date2.date, yesterday)
+
+            dates = self.date.search([
+                    ('date', '=', yesterday),
+                    ])
+            self.assertEqual(dates, [date2])
+
+            dates = self.date.search([
+                    ('date', 'in', [yesterday, today]),
+                    ])
+            self.assertEqual(dates, [date1, date2])
+
+            dates = self.date.search([
+                    ('date', 'not in', [yesterday, today]),
+                    ])
+            self.assertEqual(dates, [])
+
+            date3 = self.date.create({})
+            self.assert_(date3)
+            self.assertEqual(date3.date, None)
+
+            date4 = self.date_default.create({})
+            self.assert_(date4)
+            self.assertEqual(date4.date, default_date)
+
+            self.date.write([date1], {
+                    'date': yesterday,
+                    })
+            self.assertEqual(date1.date, yesterday)
+
+            self.date.write([date2], {
+                    'date': today,
+                    })
+            self.assertEqual(date2.date, today)
+
+            self.assertRaises(Exception, self.date.create, {
+                    'date': 'test',
+                    })
+
+            self.assertRaises(Exception, self.date.write, [date1], {
+                    'date': 'test',
+                    })
+
+            self.assertRaises(Exception, self.date.create, {
+                    'date': 1,
+                    })
+
+            self.assertRaises(Exception, self.date.write, [date1], {
+                    'date': 1,
+                    })
+
+            self.assertRaises(Exception, self.date.create, {
+                    'date': datetime.datetime.now(),
+                    })
+
+            self.assertRaises(Exception, self.date.write, [date1], {
+                    'date': datetime.datetime.now(),
+                    })
+
+            self.assertRaises(Exception, self.date.create, {
+                    'date': '2009-13-01',
+                    })
+
+            self.assertRaises(Exception, self.date.write, [date1], {
+                    'date': '2009-02-29',
+                    })
+
+            date5 = self.date.create({
+                    'date': '2009-01-01',
+                    })
+            self.assert_(date5)
+            self.assertEqual(date5.date, datetime.date(2009, 1, 1))
+
+            self.assertRaises(Exception, self.date_required.create, {})
             transaction.cursor.rollback()
 
-            date6_id = self.date_required.create({
-                'date': today,
-                })
-            self.assert_(date6_id)
-
-            date7_id = self.date.create({
-                'date': None,
-                })
-            self.assert_(date7_id)
-
-            date8_id = self.date.create({
-                'date': None,
-                })
-            self.assert_(date8_id)
+            date6 = self.date_required.create({
+                    'date': today,
+                    })
+            self.assert_(date6)
+
+            date7 = self.date.create({
+                    'date': None,
+                    })
+            self.assert_(date7)
+
+            date8 = self.date.create({
+                    'date': None,
+                    })
+            self.assert_(date8)
 
             transaction.cursor.rollback()
 
